fs          = require("fs")
gulp        = require("gulp")
header      = require("gulp-header")
isBrowser   = require("gulp-isbrowser")
coffee      = require("gulp-cjsx")
mocha       = require("gulp-mocha")
regenerator = require("gulp-regenerator")
{ merge }   = require("event-stream")
details     = require("./package.json")
src         = "./src"
client      = "./client"
server      = "./server"

try
    fs.mkdirSync(__dirname + client)
    fs.mkdirSync(__dirname + server)

###
Build all local cs.
###
gulp.task("build", ->
    stream = gulp.src("#{src}/**/*.coffee")
        .pipe(coffee({bare: true}).on("error", handleError = (err)->
            console.log(err.toString())
            console.log(err.stack)
            this.emit("end")
        ))
        .pipe(header("/** Rill v#{details.version} https://www.npmjs.com/package/rill License: MIT*/\n"))

    merge(
        stream
            .pipe(isBrowser(yes))
            .pipe(regenerator())
            .pipe(gulp.dest(client))
        stream
            .pipe(isBrowser(no))
            .pipe(gulp.dest(server))
    )
)

###
Run tests.
###
gulp.task("test", ->
    gulp.src("./test/**/*Test.coffee", read: false)
        .pipe(mocha(reporter: 'nyan'))
)
